<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>OperandResolver (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="OperandResolver (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9,"i1":9,"i2":9,"i3":9,"i4":9,"i5":9,"i6":9,"i7":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/OperandResolver.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../../org/apache/poi/ss/formula/eval/NumericValueEval.html"
               title="interface in org.apache.poi.ss.formula.eval"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../../org/apache/poi/ss/formula/eval/PercentEval.html"
               title="class in org.apache.poi.ss.formula.eval"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../../index.html?org/apache/poi/ss/formula/eval/OperandResolver.html" target="_top">Frames</a>
        </li>
        <li><a href="OperandResolver.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula.eval</div>
    <h2 title="Class OperandResolver" class="title">Class OperandResolver</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.formula.eval.OperandResolver</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public final class <span class="typeNameLabel">OperandResolver</span>
extends java.lang.Object</pre>
                <div class="block">Provides functionality for evaluating arguments to functions and operators.</div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Josh Micich, Brendan Nolan</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#chooseSingleElementFromArea-org.apache.poi.ss.formula.eval.AreaEval-int-int-">chooseSingleElementFromArea</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/AreaEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">AreaEval</a>&nbsp;ae,
                                    int&nbsp;srcCellRow,
                                    int&nbsp;srcCellCol)</code>
                                    <div class="block">Implements (some perhaps not well known) Excel functionality to
                                        select a single cell from an
                                        area depending on the coordinates of the calling cell.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>static java.lang.Boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#coerceValueToBoolean-org.apache.poi.ss.formula.eval.ValueEval-boolean-">coerceValueToBoolean</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ve,
                                    boolean&nbsp;stringsAreBlanks)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>static double</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#coerceValueToDouble-org.apache.poi.ss.formula.eval.ValueEval-">coerceValueToDouble</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ev)</code>
                                    <div class="block">Applies some conversion rules if the supplied value is not
                                        already a number.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>static int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#coerceValueToInt-org.apache.poi.ss.formula.eval.ValueEval-">coerceValueToInt</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ev)</code>
                                    <div class="block">Applies some conversion rules if the supplied value is not
                                        already an integer.<br>
                                        Value is first coerced to a <tt>double</tt> ( See <tt>coerceValueToDouble()</tt>
                                        ).
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#coerceValueToString-org.apache.poi.ss.formula.eval.ValueEval-">coerceValueToString</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ve)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#getElementFromArray-org.apache.poi.ss.formula.eval.AreaEval-org.apache.poi.ss.formula.EvaluationCell-">getElementFromArray</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/AreaEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">AreaEval</a>&nbsp;ae,
                                    <a href="../../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                       title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;cell)</code>
                                    <div class="block">Retrieves a single value from an area evaluation utilizing the 2D
                                        indices of the cell
                                        within its own area reference to index the value in the area evaluation.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#getSingleValue-org.apache.poi.ss.formula.eval.ValueEval-int-int-">getSingleValue</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;arg,
                                    int&nbsp;srcCellRow,
                                    int&nbsp;srcCellCol)</code>
                                    <div class="block">Retrieves a single value from a variety of different argument
                                        types according to standard
                                        Excel rules.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>static java.lang.Double</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/OperandResolver.html#parseDouble-java.lang.String-">parseDouble</a></span>(java.lang.String&nbsp;pText)</code>
                                    <div class="block">Converts a string to a double using standard rules that Excel
                                        would use.<br>
                                        Tolerates leading and trailing spaces,
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getSingleValue-org.apache.poi.ss.formula.eval.ValueEval-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getSingleValue</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;getSingleValue(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;arg,
                                       int&nbsp;srcCellRow,
                                       int&nbsp;srcCellCol)
                                throws <a href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                          title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></pre>
                                <div class="block">Retrieves a single value from a variety of different argument types
                                    according to standard
                                    Excel rules. Does not perform any type conversion.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>arg</code> - the evaluated argument as passed to the function or operator.
                                    </dd>
                                    <dd><code>srcCellRow</code> - used when arg is a single column AreaRef</dd>
                                    <dd><code>srcCellCol</code> - used when arg is a single row AreaRef</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a <tt>NumberEval</tt>, <tt>StringEval</tt>, <tt>BoolEval</tt> or
                                        <tt>BlankEval</tt>.
                                        Never <code>null</code> or <tt>ErrorEval</tt>.
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>EvaluationException(#VALUE!)</code> - if srcCellRow or srcCellCol do not
                                        properly index into
                                        an AreaEval. If the actual value retrieved is an ErrorEval, a corresponding
                                        EvaluationException is thrown.
                                    </dd>
                                    <dd><code><a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getElementFromArray-org.apache.poi.ss.formula.eval.AreaEval-org.apache.poi.ss.formula.EvaluationCell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getElementFromArray</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;getElementFromArray(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/AreaEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">AreaEval</a>&nbsp;ae,
                                            <a href="../../../../../../org/apache/poi/ss/formula/EvaluationCell.html"
                                               title="interface in org.apache.poi.ss.formula">EvaluationCell</a>&nbsp;cell)</pre>
                                <div class="block">Retrieves a single value from an area evaluation utilizing the 2D
                                    indices of the cell
                                    within its own area reference to index the value in the area evaluation.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>ae</code> - area reference after evaluation</dd>
                                    <dd><code>cell</code> - the source cell of the formula that contains its 2D indices
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a <tt>NumberEval</tt>, <tt>StringEval</tt>, <tt>BoolEval</tt> or
                                        <tt>BlankEval</tt>. or <tt>ErrorEval<tt>
                                            Never <code>null</code>.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="chooseSingleElementFromArea-org.apache.poi.ss.formula.eval.AreaEval-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>chooseSingleElementFromArea</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;chooseSingleElementFromArea(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/AreaEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">AreaEval</a>&nbsp;ae,
                                                    int&nbsp;srcCellRow,
                                                    int&nbsp;srcCellCol)
                                             throws <a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></pre>
                                <div class="block">Implements (some perhaps not well known) Excel functionality to
                                    select a single cell from an
                                    area depending on the coordinates of the calling cell. Here is an example
                                    demonstrating
                                    both selection from a single row area and a single column area in the same formula.

                                    <table border="1" cellpadding="1" cellspacing="1" summary="sample spreadsheet">
                                        <tr>
                                            <th>&nbsp;</th>
                                            <th>&nbsp;A&nbsp;</th>
                                            <th>&nbsp;B&nbsp;</th>
                                            <th>&nbsp;C&nbsp;</th>
                                            <th>&nbsp;D&nbsp;</th>
                                        </tr>
                                        <tr>
                                            <th>1</th>
                                            <td>15</td>
                                            <td>20</td>
                                            <td>25</td>
                                            <td>&nbsp;</td>
                                        </tr>
                                        <tr>
                                            <th>2</th>
                                            <td>&nbsp;</td>
                                            <td>&nbsp;</td>
                                            <td>&nbsp;</td>
                                            <td>200</td>
                                        </tr>
                                        <tr>
                                            <th>3</th>
                                            <td>&nbsp;</td>
                                            <td>&nbsp;</td>
                                            <td>&nbsp;</td>
                                            <td>300</td>
                                        </tr>
                                        <tr>
                                            <th>3</th>
                                            <td>&nbsp;</td>
                                            <td>&nbsp;</td>
                                            <td>&nbsp;</td>
                                            <td>400</td>
                                        </tr>
                                    </table>

                                    If the formula "=1000+A1:B1+D2:D3" is put into the 9 cells from A2 to C4, the
                                    spreadsheet
                                    will look like this:

                                    <table border="1" cellpadding="1" cellspacing="1" summary="sample spreadsheet">
                                        <tr>
                                            <th>&nbsp;</th>
                                            <th>&nbsp;A&nbsp;</th>
                                            <th>&nbsp;B&nbsp;</th>
                                            <th>&nbsp;C&nbsp;</th>
                                            <th>&nbsp;D&nbsp;</th>
                                        </tr>
                                        <tr>
                                            <th>1</th>
                                            <td>15</td>
                                            <td>20</td>
                                            <td>25</td>
                                            <td>&nbsp;</td>
                                        </tr>
                                        <tr>
                                            <th>2</th>
                                            <td>1215</td>
                                            <td>1220</td>
                                            <td>#VALUE!</td>
                                            <td>200</td>
                                        </tr>
                                        <tr>
                                            <th>3</th>
                                            <td>1315</td>
                                            <td>1320</td>
                                            <td>#VALUE!</td>
                                            <td>300</td>
                                        </tr>
                                        <tr>
                                            <th>4</th>
                                            <td>#VALUE!</td>
                                            <td>#VALUE!</td>
                                            <td>#VALUE!</td>
                                            <td>400</td>
                                        </tr>
                                    </table>

                                    Note that the row area (A1:B1) does not include column C and the column area (D2:D3)
                                    does
                                    not include row 4, so the values in C1(=25) and D4(=400) are not accessible to the
                                    formula
                                    as written, but in the 4 cells A2:B3, the row and column selection works ok.<p>

                                        The same concept is extended to references across sheets, such that even
                                        multi-row,
                                        multi-column areas can be useful.
                                    <p>

                                        Of course with carefully (or carelessly) chosen parameters, cyclic references
                                        can occur and
                                        hence this method <b>can</b> throw a 'circular reference' EvaluationException.
                                        Note that
                                        this method does not attempt to detect cycles. Every cell in the specified Area
                                        <tt>ae</tt>
                                        has already been evaluated prior to this method call. Any cell (or cell<b>s</b>)
                                        part of
                                        <tt>ae</tt> that would incur a cyclic reference error if selected by this
                                        method, will
                                        already have the value
                                        <t>ErrorEval.CIRCULAR_REF_ERROR</tt> upon entry to this method. It
                                            is assumed logic exists elsewhere to produce this behaviour.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>whatever the selected cell's evaluated value is. Never <code>null</code>. Never
                                        <tt>ErrorEval</tt>.
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></code>
                                        - if there is a problem with indexing into the area, or if the
                                        evaluated cell has an error.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="coerceValueToInt-org.apache.poi.ss.formula.eval.ValueEval-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>coerceValueToInt</h4>
                                <pre>public static&nbsp;int&nbsp;coerceValueToInt(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ev)
                            throws <a href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                      title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></pre>
                                <div class="block">Applies some conversion rules if the supplied value is not already an
                                    integer.<br>
                                    Value is first coerced to a <tt>double</tt> ( See <tt>coerceValueToDouble()</tt> ).
                                    Note - <tt>BlankEval</tt> is converted to <code>0</code>.<p>

                                        Excel typically converts doubles to integers by truncating toward negative
                                        infinity.<br>
                                        The equivalent java code is:<br>
                                        &nbsp;&nbsp;<code>return (int)Math.floor(d);</code><br>
                                        <b>not</b>:<br>
                                        &nbsp;&nbsp;<code>return (int)d; // wrong - rounds toward zero</code></div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="coerceValueToDouble-org.apache.poi.ss.formula.eval.ValueEval-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>coerceValueToDouble</h4>
                                <pre>public static&nbsp;double&nbsp;coerceValueToDouble(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ev)
                                  throws <a href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></pre>
                                <div class="block">Applies some conversion rules if the supplied value is not already a
                                    number.
                                    Note - <tt>BlankEval</tt> is converted to <a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/NumberEval.html#ZERO"><code>NumberEval.ZERO</code></a>.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>ev</code> - must be a <a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/NumberEval.html"
                                            title="class in org.apache.poi.ss.formula.eval"><code>NumberEval</code></a>,
                                        <a href="../../../../../../org/apache/poi/ss/formula/eval/StringEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>StringEval</code></a>,
                                        <a href="../../../../../../org/apache/poi/ss/formula/eval/BoolEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>BoolEval</code></a> or
                                        <a href="../../../../../../org/apache/poi/ss/formula/eval/BlankEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>BlankEval</code></a>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>actual, parsed or interpreted double value (respectively).</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>EvaluationException(#VALUE!)</code> - only if a StringEval is supplied and
                                        cannot be parsed
                                        as a double (See <tt>parseDouble()</tt> for allowable formats).
                                    </dd>
                                    <dd><code>java.lang.RuntimeException</code> - if the supplied parameter is not <a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/NumberEval.html"
                                            title="class in org.apache.poi.ss.formula.eval"><code>NumberEval</code></a>,
                                        <a href="../../../../../../org/apache/poi/ss/formula/eval/StringEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>StringEval</code></a>,
                                        <a href="../../../../../../org/apache/poi/ss/formula/eval/BoolEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>BoolEval</code></a> or
                                        <a href="../../../../../../org/apache/poi/ss/formula/eval/BlankEval.html"
                                           title="class in org.apache.poi.ss.formula.eval"><code>BlankEval</code></a>
                                    </dd>
                                    <dd><code><a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="parseDouble-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>parseDouble</h4>
                                <pre>public static&nbsp;java.lang.Double&nbsp;parseDouble(java.lang.String&nbsp;pText)</pre>
                                <div class="block">Converts a string to a double using standard rules that Excel would
                                    use.<br>
                                    Tolerates leading and trailing spaces, <p>

                                        Doesn't support currency prefixes, commas, percentage signs or arithmetic
                                        operations strings.

                                        Some examples:<br>
                                        " 123 " -&gt; 123.0<br>
                                        ".123" -&gt; 0.123<br>
                                        "1E4" -&gt; 1000<br>
                                        "-123" -&gt; -123.0<br>
                                        These not supported yet:<br>
                                        " $ 1,000.00 " -&gt; 1000.0<br>
                                        "$1.25E4" -&gt; 12500.0<br>
                                        "5**2" -&gt; 500<br>
                                        "250%" -&gt; 2.5<br></div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>null</code> if the specified text cannot be parsed as a number</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="coerceValueToString-org.apache.poi.ss.formula.eval.ValueEval-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>coerceValueToString</h4>
                                <pre>public static&nbsp;java.lang.String&nbsp;coerceValueToString(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ve)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>ve</code> - must be a <tt>NumberEval</tt>, <tt>StringEval</tt>, <tt>BoolEval</tt>,
                                        or <tt>BlankEval</tt></dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the converted string value. never <code>null</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="coerceValueToBoolean-org.apache.poi.ss.formula.eval.ValueEval-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>coerceValueToBoolean</h4>
                                <pre>public static&nbsp;java.lang.Boolean&nbsp;coerceValueToBoolean(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;ve,
                                                     boolean&nbsp;stringsAreBlanks)
                                              throws <a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>null</code> to represent blank values</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code><a
                                            href="../../../../../../org/apache/poi/ss/formula/eval/EvaluationException.html"
                                            title="class in org.apache.poi.ss.formula.eval">EvaluationException</a></code>
                                        - if ve is an ErrorEval, or if a string value cannot be converted
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/OperandResolver.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../../org/apache/poi/ss/formula/eval/NumericValueEval.html"
               title="interface in org.apache.poi.ss.formula.eval"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../../org/apache/poi/ss/formula/eval/PercentEval.html"
               title="class in org.apache.poi.ss.formula.eval"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../../index.html?org/apache/poi/ss/formula/eval/OperandResolver.html" target="_top">Frames</a>
        </li>
        <li><a href="OperandResolver.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
